<!-- Component for the update of a task -->
<template>
  <b-modal
    ref="my-modal"
    v-model="show_modal"
    hide-footer
    title="Modification"
  >
    <form
      ref="form"
      @submit.prevent="submit"
    >
      <b-container fluid>
        <b-row class="my-1">
          <b-col>
            <b-form-group
              label="Title"
              label-for="title"
              invalid-feedback="Champ obligatoire"
              :state="titleState"
            >
              <b-form-input
                id="title"
                v-model="data_to_edit.title"
                :state="titleState"
                required
              />
            </b-form-group>
          </b-col>
        </b-row>
        <b-row class="my-1">
          <b-col>
            <b-form-group
              label="Description"
              label-for="description"
              invalid-feedback="Champ obligatoire"
              :state="bodyState"
            >
              <b-form-textarea
                id="description"
                v-model="data_to_edit.body"
                placeholder="Enter something..."
                rows="3"
                max-rows="6"
                :state="bodyState"
                required
              />
            </b-form-group>
          </b-col>
        </b-row>
      </b-container>
      <b-row>
        <b-col>
          <div style="display: flex; float: right">
            <b-button
              class="mt-2"
              variant="danger"
              block
              :disabled="form_busy"
              style="margin-right: 5px"
              @click="hideModal"
            >
              Fermer
            </b-button>
            <b-button
              type="submit"
              class="mt-2"
              variant="primary"
              block
              :disabled="form_busy"
            >
              <span v-if="!form_busy">Mettre à jour</span>
              <span v-if="form_busy">
                <b-spinner
                  small
                  type="grow"
                />
                Traitement en cours ...
              </span>
            </b-button>
          </div>
        </b-col>
      </b-row>
    </form>
  </b-modal>
</template>

<script>

export default {
  name: 'Modal',
  props: {
    // The data to be updated
    dataToEdit: { type: Object, required: false, default: null },
    // To display the modal
    show: { type: Boolean, default: false }
  },
  data () {
    return {
      // Use to disable the close and update buttons
      form_busy: false
    }
  },
  computed: {
    /**
     * We listen to the change in the data to be updated and return it to the computed function to be used as a model
     * @return {{id: string, title: string, body: string, userId: number}|{id, title, body, userId: (number|default.computed.dataToEdit.userId|*)}}
     */
    data_to_edit () {
      if (this.dataToEdit) {
        return {
          id: this.dataToEdit.id,
          title: this.dataToEdit.title,
          body: this.dataToEdit.body,
          userId: this.dataToEdit.userId
        }
      }
      return {
        id: '',
        title: '',
        body: '',
        userId: 1
      }
    },
    // We listen to the props show and use it as a model to avoid a mistake
    show_modal: {
      /**
       * Returns the value of the props show
       * @return {Boolean}
       */
      get () {
        return this.show
      },
      /**
       * Sends an event to the component if there are changes in show_modal
       */
      set () {
        this.$emit('closemodalevent', false)
      }
    },
    /**
     * To validate if title is not empty
     * @return {boolean}
     */
    titleState () {
      return this.data_to_edit.title !== ''
    },
    /**
     * To validate if body is not empty
     * @return {boolean}
     */
    bodyState () {
      return this.data_to_edit.body !== ''
    }
  },
  methods: {
    /**
     * Function to close the modal
     */
    hideModal () {
      this.$refs['my-modal'].hide()
      this.$emit('closemodalevent', false)
    },
    /**
     * If title and body are non-empty then we trigger the update API and send a success event to the parent component
     */
    submit () {
      if (this.data_to_edit.title !== '' && this.data_to_edit.body !== '') {
        this.form_busy = true
        const url = 'https://jsonplaceholder.typicode.com/posts/100'
        fetch(url, {
          method: 'PUT',
          body: JSON.stringify(this.data_to_edit),
          headers: {
            'Content-type': 'application/json; charset=UTF-8'
          }
        }).then(response => response.json()).then((json) => {
          const result = { ...json, id: this.data_to_edit.id }
          this.$emit('successevent', result)
          this.form_busy = false
          this.hideModal()
        })
      }
    }
  }
}
</script>

<style scoped>

</style>
